<?php

    class xx_convert
    { //转换方面的自定义类
        /**
         * 得到当前页面编码信息
         * 返回输入、输出、扩展编码方式
         */
        public static function iconv_encoding()
        {
            return iconv_get_encoding();
        }

        /**
         * 字符转换（utf-8 => GBK）
         */
        public static function utf8_to_gbk($data)
        {
            return iconv('utf-8', 'GBK', $data);
        }

        /**
         * 字符转换（GBK => utf-8）
         */
        public static function gbk_to_utf8($data)
        {
            $str = iconv('GBK', 'utf-8', $data);

            return $str;
        }

        /**
         * 字符串/二维数组/多维数组编码转换
         * @param string $in_charset
         * @param string $out_charset
         * @param mixed $data
         **/

        public static function array_iconv($data, $in_charset = 'GBK', $out_charset = 'UTF-8')
        {
            if (!is_array($data)) {
                $output = iconv($in_charset, $out_charset, $data);
            } elseif (count($data) === count($data, 1)) {//判断是否是二维数组
                foreach ($data as $key => $value) {
                    $output[$key] = iconv($in_charset, $out_charset, $value);
                }
            } else {
                eval('$output = ' . iconv($in_charset, $out_charset, var_export($data, TRUE)) . ';');
            }
            return $output;
        }

        /**
         * 数组序列化
         */
        public static function serialize($data)
        {
            return serialize($data);
        }

        /**
         * 数组反序列化
         */
        public static function unserialize($data)
        {
            return unserialize($data);

        }

        /**
         * 数组转json
         * @param $data
         * @return string json_encode ( $value [, $options = 0 ] )
         * value: 要编码的值。该函数只对 UTF-8 编码的数据有效。
         * options:由以下常量组成的二进制掩码 JSON_HEX_QUOT, JSON_HEX_TAG, JSON_HEX_AMP, JSON_HEX_APOS, JSON_NUMERIC_CHECK, JSON_PRETTY_PRINT, JSON_UNESCAPED_SLASHES, JSON_FORCE_OBJECT, JSON_PRESERVE_ZERO_FRACTION, JSON_UNESCAPED_UNICODE, JSON_PARTIAL_OUTPUT_ON_ERROR。
         * 要注意的是 JSON_UNESCAPED_UNICODE 选项，如果我们不希望中文被编码，可以添加该选项。
         */

        public static function json_encode($data)
        { // array json编码
            return json_encode($data);
        }

        /**
         * json转数组
         * @param $data
         * @return mixed json_decode ($json_string [,$assoc = false [, $depth = 512 [, $options = 0 ]]])
         * json_string: 待解码的 JSON 字符串，必须是 UTF-8 编码数据
         * assoc: 当该参数为 TRUE 时，将返回数组，FALSE 时返回对象。
         * depth: 整数类型的参数，它指定递归深度
         * options: 二进制掩码，目前只支持 JSON_BIGINT_AS_STRING 。
         */
        public static function json_decode($data, $assoc = true)
        { // str json解码
            empty($assoc) ? $assoc = true : true;
            return json_decode($data, $assoc);
        }

        /**
         * url数组拼接字符串
         * @param $array /数组
         * @param string $ljf /连接符一般为&
         * @param string $fzf /赋值符一般为=
         * @return null|string
         */

        public static function url_array_to_str($array, $ljf = '&', $fzf = '=')
        {
            $str = null;
            foreach ($array as $key => $value) {
                $str .= $ljf . "{$key}" . $fzf . "{$value}";
            }
            return $str;
        }

        /**
         * url字符串转换为数组
         * @param $str //url字符串
         * @param string $ljf /连接符一般为&
         * @param string $fzf /赋值符一般为=
         * @return array
         */
        public static function url_str_to_array($str, $ljf = '&', $fzf = '=')
        {
            $array = array();
            $str_arr = explode($ljf, $str);
            foreach ($str_arr as $value) {
                if (empty($value)) {
                    continue;
                }
                $str = explode($fzf, $value);
                $array[$str[0]] = $str[1];
            }
            return $array;
        }

        /**
         * 批量获取字符串中间文本
         * @param $str // 源字符串
         * @param $start_str // 开始查询字符串
         * @param $length_str // 结束查询字符串
         * @return mixed // 返回数组型
         */

        public static function str_get_sub_all($str, $start_str, $length_str)
        {
            $counts = substr_count($str, $start_str);
            for ($i = 1; $i <= $counts; $i++) {
                $i1 = strpos($str, $start_str);//开始位置
                $i2 = strpos($str, $length_str);//结束位置
                if ($i1 !== false && $i2 !== false) {
                    $strs[$i] = substr($str, $i1 + strlen($start_str), $i2 - $i1 - strlen($length_str));
                    $str = substr($str, 0, $i1) . substr($str, $i2 + strlen($length_str));
                }//找到
            }
            return $strs;

        }

        /**
         * 批量替换字符串中间文本
         * @param $str // 源字符串
         * @param $start_str // 开始查询字符串
         * @param $length_str // 结束查询字符串
         * @param $text // 替换字符串
         * @return string  // 返回替换完文本
         */

        public static function str_replace_all($str, $start_str, $length_str, $text)
        {

            $counts = substr_count($str, $start_str);

            for ($i = 1; $i <= $counts; $i++) {
                $i1 = strpos($str, $start_str);//开始位置 strlen($start_str)+
                $i2 = strpos($str, $length_str);//结束位置 -strlen($length_str)
                if ($i1 !== false && $i2 !== false) {
                    $str = substr($str, 0, $i1) . $text . substr($str, $i2 + strlen($length_str));
                }//找到
            }
            $strc = strtr($str, array($text => $start_str . $text . $length_str));
            return $strc;
        }

        /**
         * 批量替换文本
         * @param $str // 源文件
         * @param array $array //替换规则 array('要改变的字符'=>'要改变为的字符')
         * @return string //返回替换源文件
         */
        public static function str_replace_array($str, $array = array())
        {
            $str = strtr($str, $array);
            return $str;
        }

    }