<?php

    class xx_crypt{//加密类
        /**
         * 动态 auth加密文本 ， 或数组
         * @param $string    //要加密/解密的字符串，或数组
         * @param string $key    密匙
         * @param int $expiry    有效期,单位秒，超过秒数就无法破解
         * @return string
         */
        public static function authcode_EN($string,  $key = 'encrypt', $expiry = 0)
        {
            if ( is_array($string)){
                $string = serialize($string);
            }
            return self::authcode($string,'ENCODE',$key,$expiry);
        }

        /**
         * 动态 auth解密文本 ， 或数组
         * @param $string    //要加密/解密的字符串，或数组
         * @param string $key    密匙
         * @return string
         */
        public static function authcode_DE($string,  $key = 'encrypt')
        {
            $string = self::authcode($string,'DECODE',$key);
            $arr = unserialize($string);
            if (is_array($arr)){
                return $arr;
            }else{
                return $string;
            }
        }

        /**
         * 动态 加密  auth 类库，只允许本对象内访问
         * @param $string //要加密/解密的字符串
         * @param string $operation //类型，ENCODE 加密；DECODE 解密
         * @param string $key //密匙
         * @param int $expiry //有效期 秒
         * @return false|string
         */
        protected static function authcode($string, $operation = 'DECODE', $key = '', $expiry = 0) {
            $ckey_length = 4;
            $key = md5($key != '' ? $key : getglobal('authkey'));
            $keya = md5(substr($key, 0, 16));
            $keyb = md5(substr($key, 16, 16));
            $keyc = $ckey_length ? ($operation == 'DECODE' ? substr($string, 0, $ckey_length): substr(md5(microtime()), -$ckey_length)) : '';

            $cryptkey = $keya.md5($keya.$keyc);
            $key_length = strlen($cryptkey);

            $string = $operation == 'DECODE' ? base64_decode(substr($string, $ckey_length)) : sprintf('%010d', $expiry ? $expiry + time() : 0).substr(md5($string.$keyb), 0, 16).$string;
            $string_length = strlen($string);

            $result = '';
            $box = range(0, 255);

            $rndkey = array();
            for($i = 0; $i <= 255; $i++) {
                $rndkey[$i] = ord($cryptkey[$i % $key_length]);
            }

            for($j = $i = 0; $i < 256; $i++) {
                $j = ($j + $box[$i] + $rndkey[$i]) % 256;
                $tmp = $box[$i];
                $box[$i] = $box[$j];
                $box[$j] = $tmp;
            }

            for($a = $j = $i = 0; $i < $string_length; $i++) {
                $a = ($a + 1) % 256;
                $j = ($j + $box[$a]) % 256;
                $tmp = $box[$a];
                $box[$a] = $box[$j];
                $box[$j] = $tmp;
                $result .= chr(ord($string[$i]) ^ ($box[($box[$a] + $box[$j]) % 256]));
            }

            if($operation == 'DECODE') {
                if((substr($result, 0, 10) == 0 || substr($result, 0, 10) - time() > 0) && substr($result, 10, 16) == substr(md5(substr($result, 26).$keyb), 0, 16)) {
                    return substr($result, 26);
                } else {
                    return '';
                }
            } else {
                return $keyc.str_replace('=', '', base64_encode($result));
            }
        }


        /**
         * 静态 encrypt 加密文本 ， 或数组
         * @param $string    //要加密/解密的字符串，或数组
         * @param string $key    密匙
         * @return string
         */
        public static function encrypt_E($string,$key = 'encrypt')
        {
            if ( is_array($string)){
                $string = serialize($string);
            }
            return self::encrypt($string,'E',$key);
        }

        /**
         * 静态 encrypt 解密文本 ， 或数组
         * @param $string    //要加密/解密的字符串，或数组
         * @param string $key    密匙
         * @return string
         */
        public static function encrypt_D ($string,  $key = 'encrypt')
        {
            $string = self::encrypt($string,'D',$key);
            $arr = unserialize($string);
            if (is_array($arr)){
                return $arr;
            }else{
                return $string;
            }
        }

        /**
         * 静态 encrypt  加密类型
         * @param $string    //要加密/解密的字符串
         * @param $operation   // 类型，E 加密；D 解密
         * @param string $key   密钥
         * @return mixed|string
         */
        protected static function encrypt($string, $operation, $key = 'encrypt')
        {
            $key = md5($key);
            $key_length = strlen($key);
            $string = $operation == 'D' ? base64_decode($string) : substr(md5($string . $key), 0, 8) . $string;
            $string_length = strlen($string);
            $rndkey = $box = array();
            $result = '';
            for ($i = 0; $i <= 255; $i++) {
                $rndkey[$i] = ord($key[$i % $key_length]);
                $box[$i] = $i;
            }
            for ($j = $i = 0; $i < 256; $i++) {
                $j = ($j + $box[$i] + $rndkey[$i]) % 256;
                $tmp = $box[$i];
                $box[$i] = $box[$j];
                $box[$j] = $tmp;
            }
            for ($a = $j = $i = 0; $i < $string_length; $i++) {
                $a = ($a + 1) % 256;
                $j = ($j + $box[$a]) % 256;
                $tmp = $box[$a];
                $box[$a] = $box[$j];
                $box[$j] = $tmp;
                $result .= chr(ord($string[$i]) ^ ($box[($box[$a] + $box[$j]) % 256]));
            }
            if ($operation == 'D') {
                if (substr($result, 0, 8) == substr(md5(substr($result, 8) . $key), 0, 8)) {
                    return substr($result, 8);
                } else {
                    return '';
                }
            } else {
                return str_replace('=', '', base64_encode($result));
            }
        }
    }