<?php

    class xx_curl{
        /**
         * get访问url网址接口
         * @param $url
         * @return bool|string
         */
        public static function get_url($url)//get 网页地址
        {
            // header传送格式
            $headers = array();
            // 初始化
            $curl = curl_init();
            // 设置url路径
            curl_setopt($curl, CURLOPT_URL, $url);
            // 将 curl_exec()获取的信息以文件流的形式返回，而不是直接输出。
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
            // 在启用 CURLOPT_RETURNTRANSFER 时候将获取数据返回
            curl_setopt($curl, CURLOPT_BINARYTRANSFER, true);
            // 添加头信息
            curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);
            // CURLINFO_HEADER_OUT选项可以拿到请求头信息
            curl_setopt($curl, CURLINFO_HEADER_OUT, true);
            // 不验证SSL
            curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
            curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, FALSE);
            // 执行
            $data = curl_exec($curl);
            // 打印请求头信息
//        echo curl_getinfo($curl, CURLINFO_HEADER_OUT);
            // 关闭连接
            curl_close($curl);
            // 返回数据
            return $data;
        }


        /**
         * post访问url地址，并提交数据
         * @param $url //地址
         * @param $post_data //数组型
         * @return bool|string
         */
        public static function post_url($url, $post_data)//post网页地址
        {
            // header传送格式
            $headers = array();
            //初始化
            $curl = curl_init();
            //设置抓取的url
            curl_setopt($curl, CURLOPT_URL, $url);
            //设置头文件的信息作为数据流输出
            curl_setopt($curl, CURLOPT_HEADER, false);
            //设置获取的信息以文件流的形式返回，而不是直接输出。
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
            //设置post方式提交
            curl_setopt($curl, CURLOPT_POST, true);
            // 设置post请求参数
            curl_setopt($curl, CURLOPT_POSTFIELDS, $post_data);
            // CURLINFO_HEADER_OUT选项可以拿到请求头信息
            curl_setopt($curl, CURLINFO_HEADER_OUT, true);
            // 不验证SSL
            curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, FALSE);
            curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, FALSE);
            //执行命令
            $data = curl_exec($curl);
            // 打印请求头信息
//        echo curl_getinfo($curl, CURLINFO_HEADER_OUT);
            //关闭URL请求
            curl_close($curl);
            //显示获得的数据
            return $data;
        }
    
    
        /**
         * post访问url地址，并提交json数据
         * @param $url
         * @param $data_string //json
         * @return false|string
         */
        public static function post_url_json($url, $data_string) {
        
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_URL, $url);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
            curl_setopt($ch, CURLOPT_HTTPHEADER, array(
                    'Content-Type: application/json; charset=utf-8',
                    'Content-Length: ' . strlen($data_string))
            );
            ob_start();
            curl_exec($ch);
            $return_content = ob_get_contents();
            //echo $return_content."<br>";
            ob_end_clean();
        
            $return_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
            // return array($return_code, $return_content);
            return $return_content;
        }
        
        /**
         * 自动跳转页面登录状态
         * @param $uid // 设置用户uid
         * @param $url //打开指定网址
         * @param $jump //是否跳转
         */
        public static function send_url($uid,$url='',$jump=false)
        {//url是跳转网址 jump是否跳转
            global $_G;
            //通过正确的result，执行核心方法getuserbyuid()获取该用户的所有信息
            $member = getuserbyuid($uid, 1);
            //使用source/function/function_member.php内的setloginstatus()方法，将用户变更登录状态，同时初始化应用程序(包括G变量)
            require_once libfile('function/member');
            $cookietime = 1296000;
            setloginstatus($member, $cookietime);
            //设置缓存、lastip等用户登录信息
            dsetcookie('lip', $_G['member']['lastip'] . ',' . $_G['member']['lastvisit']);
            C::t('common_member_status')->update($uid, array('lastip' => $_G['clientip'], 'lastvisit' => TIMESTAMP));
            if (empty($url)){
                $url = $_G['siteurl'];
            }
            if (empty($jump)) {
                dheader("Location:$url");
            } else {
                xx_client::json_output(200,'',$_COOKIE);
            }
        }
        /**
         * JS提示跳转
         * @param  $tip  弹窗口提示信息(为空没有提示)
         * @param  $type 设置类型 close = 关闭 ，back=返回 ，refresh=提示重载，jump提示并跳转url
         * @param  $url  跳转url
         */
        public static function alert($tip = "", $type = "", $url = "") {
            $js = "<script>";
            if ($tip)
                $js .= "alert('" . $tip . "');";
            switch ($type) {
                case "close" : //关闭页面
                    $js .= "window.close();";
                    break;
                case "back" : //返回
                    $js .= "history.back(-1);";
                    break;
                case "refresh" : //刷新
                    $js .= "parent.location.reload();";
                    break;
                case "top" : //框架退出
                    if ($url)
                        $js .= "top.location.href='" . $url . "';";
                    break;
                case "jump" : //跳转
                    if ($url)
                        $js .= "window.location.href='" . $url . "';";
                    break;
                default :
                    break;
            }
            $js .= "</script>";
            echo $js;
            if ($type) {
                exit();
            }
        }
    
        /**
           *$msg 信息提示的内容
           *$gourl 需要跳转的网址
           *$onlymsg 1 表示不自动跳转 0表示自动跳转
           *$limittime 跳转的时间
           */
        public static function ShowMsg($msg, $gourl, $onlymsg = 0, $limittime = 0) //系统提示信息
        {
           
            global $dsql, $cfg_ver_lang;
            if (!preg_match ( "^gb", $cfg_ver_lang ))
                $cfg_ver_lang = 'utf-8';
            $htmlhead = "<html>\r\n<head>\r\n<title>系统提示</title>\r\n<meta http-equiv=\"Content-Type\" content=\"text/html; charset={$cfg_ver_lang}\" />\r\n";
            $htmlhead .= "<base target='_self'/>\r\n</head>\r\n<body leftmargin='0' topmargin='0'>\r\n<center>\r\n<script>\r\n";
            $htmlfoot = "</script>\r\n</center>\r\n</body>\r\n</html>\r\n";
            if ($limittime == 0)
                $litime = 5000;
            else
                $litime = $limittime;
            if ($gourl == "-1") {
                if ($limittime == 0)
                    $litime = 5000;
                $gourl = "javascript:history.go(-1);";
            }
            if ($gourl == "" || $onlymsg == 1) {
                $msg = "<script>alert(\"" . str_replace ( "\"", "“", $msg ) . "\");</script>";
            } else {
                $func = "  var pgo=0;
  function JumpUrl(){
  if(pgo==0){ location='$gourl'; pgo=1; }
  }\r\n";
                $rmsg = $func;
                $rmsg .= "document.write(\"<br/><div style='width:400px;padding-top:4px;height:24;font-size:10pt;border-left:1px solid #999999;border-top:1px solid #999999;border-right:1px solid #999999;background-color:#CCC;'>系统提示信息：</div>\");\r\n";
                $rmsg .= "document.write(\"<div style='width:400px;height:100;font-size:10pt;border:1px solid #999999;background-color:#f9fcf3'><br/><br/>\");\r\n";
                $rmsg .= "document.write(\"" . str_replace ( "\"", "“", $msg ) . "\");\r\n";
                $rmsg .= "document.write(\"";
                if ($onlymsg == 0) {
                    if ($gourl != "javascript:;" && $gourl != "") {
                        $rmsg .= "<br/><br/><a href='" . $gourl . "'>如果你的浏览器没反应，请点击这里...</a>";
                    }
                    $rmsg .= "<br/><br/></div>\");\r\n";
                    if ($gourl != "javascript:;" && $gourl != "") {
                        $rmsg .= "setTimeout('JumpUrl()',$litime);";
                    }
                } else {
                    $rmsg .= "<br/><br/></div>\");\r\n";
                }
                $msg = $htmlhead . $rmsg . $htmlfoot;
            }
            if (isset ( $dsql ) && is_object ( $dsql ))
                @$dsql->Close ();
            echo $msg;
        }
        
        
        
    }
