<?php

    class xx_mysql{
        /**
         * 设置临时数据库配置文件
         * @param $host //服务器地址
         * @param $user //数据库用户名
         * @param $name //数据库名
         * @param $pw //数据库密码
         * @return array //返回原数据库配置文件，配合退出数据库方法适用
         */
        public static function set_db_config($host,$user,$name,$pw){//设置数据库配置文件
            DB::$db;
            $oldsql = array(
                'dbhost'=>DB::$db->config[1]['dbhost'],
                'dbuser'=> DB::$db->config[1]['dbuser'],
                'dbname'=>DB::$db->config[1]['dbname'],
                'dbpw'=>DB::$db->config[1]['dbpw'],
            );
            DB::$db->config[1]['dbhost'] = $host;
            DB::$db->config[1]['dbuser'] = $user;
            DB::$db->config[1]['dbname'] = $name;
            DB::$db->config[1]['dbpw'] = $pw;
            DB::$db->connect();
            return $oldsql;
        }

        /**
         * 返回数据库
         * @param array $arr //提交切换数据库返回配置文件
         * @return mixed
         */
        public static function exit_db($arr= array()){//切换数据库
            DB::$db->config[1]['dbhost'] = $arr['dbhost'];
            DB::$db->config[1]['dbuser'] = $arr['dbuser'];
            DB::$db->config[1]['dbname'] = $arr['dbname'];
            DB::$db->config[1]['dbpw'] = $arr['dbpw'];
            DB::$db->connect();
            return DB::$db->config[1];
        }


        /**
         * 数据库数组导出csv文件表格
         * @param $filename //fopen打开的文件地址，默认是根目录，下一次更新
         * @param $header //导出标题1、2、3、4、5   $header = array('字段1','字段2','字段3');
         * @param $array //导出数据 $data = array(1=>array('1111','2222','3333'),2=>array('44444444','55555','36666333'),3=>array('7777','888','9999'));
         * @param $jump //url是跳转网址 jump是否跳转
         * @return string|void //返回文件下载地址
         */

        public static function arraytocsv($filename, $header, $array = array(),$jump=false)
        {
            global $_G;
            $file = DISCUZ_ROOT.'data/cache/xinxiuvip_network/csv/'.$filename;
            if (!file_exists($file)){
                mkdir(dirname($file),0777, true);
            }
            $file = fopen($file, 'w');
            fputcsv($file, $header);
            foreach ($array as $value) {
                fputcsv($file, $value);
            }
            fclose($file);
            $url= $_G['siteurl'].'data/cache/xinxiuvip_network/csv/'.$filename;
            if ($jump == false) {
                return  $url;
            } else {
                dheader("Location:$url");
            }
        }

        /**
         * 模糊搜索数据库返回数据
         * @param $table  //搜索表名称
         * @param $rule //搜索规则 接口规则“或”和“且”用“|”分开，多关键字用“-”分开
         * 例：标-的|标-题（包含标或的，且必须包含标和题）
         * 例：标题 （搜索包含标题的帖子）
         * 例：标题-发现（搜索包含标题或发现的帖子）
         * @param $ruletab //搜索字段
         * @param string $field //返回字段array
         * @param string $order //排序字段
         * @param string $start //开始数据
         * @param string $limit //结束数据
         * @param string $sort //排序规则
         * @return array
         */

        public static function fetch_all_search ($table,$rule,$ruletab,$field = "id",$order = "id",$start = "",$limit = "",$sort = ''){//通过用户名搜索用户

            $where_or = "";//搜索方法or
            $where_and = "";//搜索方法and
            empty($start) ? $start = 0 : true;
            empty($limit) ? $limit = 10 : true;
            empty($sort) ? $sort = 'DESC' : $sort = 'ASC' ;
            $field == "id" ? true : $field = implode(",",$field);
            $str_explode = explode("|",$rule);

            if ($str_explode[0]){//或的规则
                $str = explode("-",$str_explode[0]);
                foreach($str as $key => $value){
                    empty($key) ? $where_or = $ruletab." like '%".$value."%'" : $where_or .= " or ".$ruletab." like '%".$value."%'" ;
                }
            }
            if ($str_explode[1]){//且的规则
                $str = explode("-",$str_explode[1]);
                foreach($str as $key => $value){
                    $where_and .= " and ".$ruletab." like '%".$value."%'" ;
                }
            }

            $str =  DB::fetch_all("SELECT ".$field." from ".DB::table($table)." where 1=1 and (".$where_or.")".$where_and.($sort ? ' ORDER BY '.DB::order($order, $sort) : '').DB::limit($start, $limit));
            $str_counts =  DB::fetch_all("SELECT ".$field." from ".DB::table($table)." where 1=1 and (".$where_or.")".$where_and.($sort ? ' ORDER BY '.DB::order($order, $sort) : ''));
            $str['counts'] = count($str_counts);
            return $str;
        }

        /**
         * 搜索返回数据内容
         * @param $table  //搜索表名称
         * @param $ruletab //搜索字段规则 例如 id=1
         * @param string $field //返回字段array
         * @param string $order //排序字段
         * @param string $start //开始数据
         * @param string $limit //结束数据
         * @param string $sort //排序规则
         * @return array
         * 实例如下：
         * return xx_mysql::fetch_all("common_usergroup_field","1=1",array("groupid","readaccess","allowpost"),"groupid");
         */
        public static function fetch_all ($table,$ruletab,$field,$order = "id",$start = "",$limit = "",$sort = ''){//通过用户名搜索用户
            empty($start) ? $start = 0 : true;
            empty($limit) ? $limit = 10 : true;
            empty($sort) ? $sort = 'DESC' : $sort = 'ASC' ;
            empty($ruletab) ? $ruletab = "1=1" : true;
            empty($field) ? $field = "*" : $field = implode(",",$field);
            $str =  DB::fetch_all("SELECT ".$field." from ".DB::table($table)." where ".$ruletab.($sort ? ' ORDER BY '.DB::order($order, $sort) : '').DB::limit($start, $limit));
            $str_counts =  DB::fetch_all("SELECT ".$field." from ".DB::table($table)." where ".$ruletab.($sort ? ' ORDER BY '.DB::order($order, $sort) : ''));
            $str['counts'] = count($str_counts);
            return $str;
        }
        /**
         * 搜索返回数据整条内容
         * @param $table  //搜索表名称
         * @param $ruletab //搜索字段规则 例如 id=1
         * @param string $field //返回字段array
         * @return array
         * 实例如下：
         * return xx_mysql::fetch_first('common_credit_log','uid=3',array());
         */
        public static function fetch_first ($table,$ruletab,$field =false){//通过用户名搜索用户
            empty($ruletab) ? $ruletab = "1=1" : true;
            empty($field) ? $field = "*" : $field = implode(",",$field);
            $str =  DB::fetch_first("SELECT ".$field." from ".DB::table($table)." where ".$ruletab);
            return $str;
        }

        /* 数据表更新操作
         * 方法名：DB::update()
         * 插入的值如果是变量用array(),DB::update('borle_do',array('countMoney' => $countMoney),array('doId'=> $doId),true);}
         * $table：（更新数据的表）
         * $data：更新的数据，字段对应的
         * $condition：更新的条件，必须包含主键id
         * $unbuffrerd：是否使用无缓存查询
         * $low_priority:是否采用无损更新表
         */
        public static function update_all($table,$data,$condition){//更新数据表内容
            $data =  DB::update($table,$data,$condition,true,true);
            return $data;
        }

        /*
         * 数据表删除操作
            方法名：DB::delete()
            参数解释：
            $table：删除数据的表
            $condition：删除条件 支持uid=1文本，也支持数组，数组传入时都是并为真执行
            $limit：删除满足条件的目数
            $unbuffered:是否使用无缓存查询
         */
        public static function delete($table,$condition,$limit=1){//删除制定uid数据
            if (empty($condition)) {
                return false;
            }else{
                $where = $condition;
            }
            $data =  DB::delete($table,$where,$limit,true);
            return $data;
        }

        /*
         * 数据库插入数据
         * $table:插入数据的表 $data：插入的数据，字段对应值
         * $dataarray 插入数据数组
         * $return_insert_id：是否返回插入数据的ID
         * $replace：是否使用replace into  如果为真： 当存在数据执行修改，不存在执行写入，返回uid，注意数组重必须包含主键uid array('uid' => '1','dname' => 'ppc', )
         * $slient：操作失败是否不提示
        */

        public static function insert($table,$dataarray='',$replace = false){//数据表插入！
            if (empty($dataarray)) {
                return false;
            }else{
                $where = $dataarray;
            }
            $data = DB::insert($table,$where,true,$replace,true);
            return $data;
        }

        /**
         * 执行多行sql语句
         * @param $sql //多行sql语句
         */
        public static function runquery($sql){
            require_once DISCUZ_ROOT.'./source/function/function_plugin.php';
            @runquery($sql);
        }

        
        
        //*****************************
        //以下是等待测试的代码没有实际功能或调用
        //*****************************
        /**
         * 多表联查
         */
        public static function fetch_alls(){

        $str = DB::fetch_all("SELECT a.uid,b.oltime,c.privacy FROM %t a LEFT JOIN %t b ON a.uid = b.uid LEFT JOIN %t c ON a.uid = c.uid WHERE a.uid = %d" ,array('common_member','common_member_count','common_member_field_home',1));
        $str = DB::fetch_all("SELECT * FROM %t a LEFT JOIN %t b ON a.uid = b.uid WHERE a.uid = %d" ,array('common_member','common_member_count',1));

        }
        public function diy_result_first($ziduan,$table,$uid){//单字段内容查询，通过uid来查询，参数分别为：字段名称、表名称、uid
            $data = DB::result_first('select '.$ziduan.' from %t where uid=%d',array($table,$uid));
            return $data;
        }
    
        public function diy_result_first_count($table){//通过表查询存在的条目数
            $data = DB::result_first('select count(*) from %t ',array($table));
            return $data;
        }
    
        public function diy_result_first_max($table,$uid='uid'){//通过表和主键查询主键最大值,默认uid为主键
            $data = DB::result_first('select max(%s) from %t',array($uid,$table));
            return $data;
        }
        /*
         * $table:插入数据的表 $data：插入的数据，字段对应值 $return_insert_id：是否返回插入数据的ID $replace：是否使用replace into $slient：操作失败是否不提示
         */
        public function diy_insert($table,$dataarray=''){//数据表插入！$replace 当存在数据执行修改，不存在执行写入，返回uid，注意数组重必须包含主键uid array('uid' => '1','dname' => 'ppc', )
            $data = DB::insert($table,$dataarray,true,true,true);
            return $data;
        }
        /*
         * 数据表删除操作
            方法名：DB::delete()
            参数解释：
            $table：删除数据的表
            $condition：删除条件
            $limit：删除满足条件的目数
            $unbuffered:是否使用无缓存查询
         */
        public function diy_delete($table,$uid,$limit=1){//删除制定uid数据
            $data =  DB::delete($table,'uid='.$uid,$limit,true);
            return $data;
        }
        /* 数据表更新操作
         * 方法名：DB::update()
         * 插入的值如果是变量用array(),DB::update('borle_do',array('countMoney' => $countMoney),array('doId'=> $doId),true);}
         * $table：（更新数据的表）
         * $data：更新的数据，字段对应的
         * $condition：更新的条件
         * $unbuffrerd：是否使用无缓存查询
         * $low_priority:是否采用无损更新表
         */
        public function diy_update($table,$array,$uid){//更新数据表内容
            $data =  DB::update($table,$array,'uid='.$uid,true,true);
            return $data;
        }
        ////绑定查询的参数解释
        ////表达式	数据处理
        ////%t	DB::table()
        ////%d	Intval()
        ////%s	addslashes
        ////%n	IN(1,2,3)
        ////%f	Sprintf(‘%f,%var’)
        ////%i	不做任何处理
    
        /*
         * 单条查询
         * $sql:查询数据的sql语句   $arg:绑定查询的参数    $silent:查询失败时是否不提示
         */
        public function diy_fetch_first($table,$uid){//单条查询，输入表名，及uid，查询整个字段
            $data = DB::fetch_first('SELECT * FROM %t WHERE uid=%d',array($table,$uid));
        
            return $data;
        }
        /*
         * 多条查询
         * $sql:查询数据的sql语句   $arg:绑定查询的参数    $silent:查询失败时是否不提示
         */
        public function diy_fetch_first_all($table,$uid){//查询一条所有字段数据，输入表名，及uid，查询整个字段
            $data = DB::fetch_all('SELECT * FROM %t WHERE uid=%d',array($table,$uid));
//        $data = $data['0'];
            return $data;
        }
        public function sqldomo(){ //特殊代码演示
            //用于查询数据库中 type字段不同值的返回
            DB::fetch_all('SELECT DISTINCT type FROM %t WHERE id > %d',array('xinxiuvip_network_codepays',0));
            //完整的查询代码
            $logs = DB::fetch_all('SELECT * FROM '.DB::table('xinxiuvip_network_actions').' WHERE id > 0 '.' ORDER BY '.DB::order('id', 'DESC').DB::limit($start, $perpage), null);
            //where语句的运用
            $str = <<<EOT

 DB::result_first('select lastactivity from %t where uid=%d',array('xinxiuvip_network_token',13));
string(10) "1699317863"
 DB::fetch_first('select lastactivity from %t where uid=%d',array('xinxiuvip_network_token',13));
array(1) {
  ["lastactivity"]=>
  string(10) "1699317863"
}

            一、WHERE 子句中的运算符
                下面的运算符可以在 WHERE 子句中使用：
                运算符	描述
                =	等于
                <>	不等于。注释：在 SQL 的一些版本中，该操作符可被写成 !=
                >	大于
                <	小于
                >=	大于等于
                <=	小于等于
                BETWEEN	在某个范围内
                LIKE	搜索某种模式
                IN	指定针对某个列的多个可能值
            二、and 和  or 的组合使用
            Country='Germany' AND (City='Berlin' OR City='München');
            三、SQL Aggregate 函数
            SQL Aggregate 函数计算从列中取得的值，返回一个单一的值。有用的 Aggregate 函数：
            AVG() - 返回平均值
            COUNT() - 返回行数
            FIRST() - 返回第一个记录的值
            LAST() - 返回最后一个记录的值
            MAX() - 返回最大值
            MIN() - 返回最小值
            SUM() - 返回总和
            SQL Scalar 函数
            四、SQL Scalar 函数基于输入值，返回一个单一的值。有用的 Scalar 函数：
            UCASE() - 将某个字段转换为大写
            LCASE() - 将某个字段转换为小写
            MID() - 从某个文本字段提取字符
            LEN() - 返回某个文本字段的长度
            ROUND() - 对某个数值字段进行指定小数位数的四舍五入
            NOW() - 返回当前的系统日期和时间
            FORMAT() - 格式化某个字段的显示方式
EOT;
        }
    
    
    
        public function diy_fetch_all($table,$uid1,$uid2){//查询多条，输入表名，及uid，查询整个字段
            $data = DB::fetch_all('SELECT * FROM %t WHERE uid >= %d and uid <= %d',array($table,$uid1,$uid2));
            return $data;
        }
    
        /*
         * 参数解释：$sql：查询数据的SQL语句  $arg：绑定查询的参数   $keyfield：一维索引的字段名称   $silent：查询失败的是否不提示
         */
        public function diy_fetch_all_n($table,$array){//用in数组查询多条，输入表名，及uid数组
            $data = DB::fetch_all("select * from %t where uid in (%n)",array($table,$array));
            return $data;
        }

    }
